Attribute VB_Name = "ModPublic"
Option Explicit


Public Function SurroundIT(Field As String, RightBefore As String, RightAfter As String, _
                 Html_Text As String, Optional pos As Long = 1, Optional AllowLength As Long = 500) As String
 Dim html As String
 Dim Result As String
 Dim tic As Long
 Dim tac As Long
 Dim Trunk As String
 
 If pos <= 0 Then pos = 1
 html = Html_Text
 If Len(Trim(html)) > 0 Then
    tac = InStr(pos, html, Field)
    If tac > 0 Then
      pos = tac + 1
      Trunk = Mid(html, tac, AllowLength)
      Result = StripIT(Field, RightAfter, Trunk, , True, True)
    End If
    If tac > 0 Then tic = InStrRev(Result, RightBefore)
    If tic > 0 Then
      SurroundIT = Trim(Mid(Result, tic + Len(RightBefore)))
      pos = tac
    Else
      SurroundIT = Result
    End If
 End If  'Found Header Field in HTML
End Function


Public Function StripIT(Hdr As String, ftr As String, FullString As String, _
                        Optional StartAT As Long, Optional Search2ndPast1st As Boolean = False, _
                        Optional RemoveHeaderFromResult As Boolean = False) As String

'Modified 2004-12-09
'added If header isnt found before end of search it will return up to the end IF :
'   o ftr is blank
'   o ftr is space(1)

'Added RemoveHeaderFromResult
'   o False Example :   Fullstring = "Hello=World" : Hdr="Hello=World" Ftr="" : Result "Hello=World"
'   o True Example  :   Fullstring = "Hello=World" : Hdr="Hello=" ftr="" : Result = "World"
 
 Dim B As Long
 Dim E As Long
 Dim s As Long
 
 If StartAT > 0 Then s = StartAT Else s = 1
 StripIT = ""
 
 B = InStr(s, LCase(FullString), LCase(Hdr))
 If RemoveHeaderFromResult And B > 0 And Len(Hdr) > 0 Then
  B = B + Len(Hdr) - 1
 End If
 
 E = InStr(IIf(Search2ndPast1st, B + 1, s + 1), LCase(FullString), LCase(ftr))
 If ftr = "" Then E = 0
 
 If E > 0 Then StartAT = E + 1
 If (B = E) Or (E = B + 1) Then
  StripIT = ""
 ElseIf B > 0 And E > 0 Then
  StripIT = Trim$(Mid$(FullString, B + 1, E - B - 1))
 ElseIf B > 0 And (Len(ftr) = 0 Or ftr = " " Or E = 0) Then
  StripIT = Trim$(Mid$(FullString, B + 1))
 End If
 StripIT = Replace(StripIT, vbCrLf, "")
 StripIT = Replace(StripIT, vbTab, "")
 StripIT = Replace(StripIT, vbCr, "")
 StripIT = Replace(StripIT, vbLf, "")
 StripIT = Trim(StripIT)
End Function


