VERSION 5.00
Begin VB.Form TLSForm 
   Caption         =   "TLS 1.2 Test"
   ClientHeight    =   6495
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   9690
   LinkTopic       =   "Form1"
   ScaleHeight     =   6495
   ScaleWidth      =   9690
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton WinHTTPBtn 
      Caption         =   "WinHttp.WinHttpRequest.5.1"
      Height          =   375
      Left            =   60
      TabIndex        =   1
      Top             =   6060
      Width           =   2535
   End
   Begin VB.CommandButton MSXMLHttpBtn 
      Caption         =   "MSXML2.XMLHTTP.6.0"
      Height          =   375
      Left            =   7080
      TabIndex        =   3
      Top             =   6060
      Width           =   2535
   End
   Begin VB.CommandButton MSXMLServerBtn 
      Caption         =   "MSXML2.ServerXMLHTTP.6.0"
      Height          =   375
      Left            =   3540
      TabIndex        =   2
      Top             =   6060
      Width           =   2535
   End
   Begin VB.TextBox Text1 
      CausesValidation=   0   'False
      Height          =   5895
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   60
      Width           =   9555
   End
End
Attribute VB_Name = "TLSForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'See https://docs.microsoft.com/en-us/windows/win32/winhttp/winhttprequestoption for more info on these options
Const WinHttpRequestOption_UserAgentString = 0
Const WinHttpRequestOption_URL = 1
Const WinHttpRequestOption_URLCodePage = 2
Const WinHttpRequestOption_EscapePercentInURL = 3
Const WinHttpRequestOption_SslErrorIgnoreFlags = 4
Const WinHttpRequestOption_SelectCertificate = 5
Const WinHttpRequestOption_EnableRedirects = 6
Const WinHttpRequestOption_UrlEscapeDisable = 7
Const WinHttpRequestOption_UrlEscapeDisableQuery = 8
Const WinHttpRequestOption_SecureProtocols = 9
Const WinHttpRequestOption_EnableTracing = 10
Const WinHttpRequestOption_RevertImpersonationOverSsl = 11
Const WinHttpRequestOption_EnableHttpsToHttpRedirects = 12
Const WinHttpRequestOption_EnablePassportAuthentication = 13
Const WinHttpRequestOption_MaxAutomaticRedirects = 14
Const WinHttpRequestOption_MaxResponseHeaderSize = 15
Const WinHttpRequestOption_MaxResponseDrainSize = 16
Const WinHttpRequestOption_EnableHttp1_1 = 17
Const WinHttpRequestOption_EnableCertificateRevocationCheck = 18
Const SecureProtocol_TLS1 = 128
Const SecureProtocol_TLS1_1 = 512
Const SecureProtocol_TLS1_2 = 2048
Const SslErrorFlag_Ignore_All = &H3300

Private Sub MSXMLServerBtn_Click()
  Dim tls As Double
  
    On Error GoTo err_MSXMLServerBtn_Click
    ' Create a reference to "Microsoft XML, V6.0" (Project->References) if you want to use the next line
    ' and rem out the 2 lines that follow this:
    ' Dim objhttp As New msxml2.ServerXMLHTTP60
    Text1.Text = ""
    Dim objhttp As Object
    Set objhttp = CreateObject("Msxml2.ServerXMLHTTP.6.0")
    With objhttp
        'Allow 5 seconds for everything to do what it has to do
        .setTimeouts 5000, 5000, 5000, 5000
        .Open "GET", "https://www.howsmyssl.com/a/check", False
        .setRequestHeader "User-Agent", "Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0"
        .setRequestHeader "Content-type", "text/html"
        .send
        tls = retTLS(.responseText)
        Text1.Text = String$(160, "-") & vbCrLf & "MSXML2.ServerXMLHTTP.6.0 - " & _
                     "TLS Max Version : " + CStr(tls) & vbCrLf & _
                     String$(160, "-") & vbCrLf & .getAllResponseHeaders & vbCrLf & .responseText & vbCrLf & Text1.Text
    End With

exit_MSXMLServerBtn_Click:
    Set objhttp = Nothing
    Exit Sub

err_MSXMLServerBtn_Click:
    MsgBox "Error " & Err.Number & ": " & Err.Description, , "Error " & Err.Number
    Resume exit_MSXMLServerBtn_Click
End Sub

Private Function retTLS(html As String) As Double
  Dim parse As String
  
  parse = SurroundIT("tls_version", "TLS", Chr(34) + ",", html)
  If IsNumeric(parse) Then
    retTLS = CDbl(parse)
  End If
End Function

Private Sub MSXMLHttpBtn_Click()
    Dim tls As Double
    
    On Error GoTo err_MSXMLHttpBtn_Click
    
    ' Create a reference to "Microsoft XML, V6.0" (Project->References) if you want to use the next line
    ' and rem out the 2 lines that follow this:
    ' Dim objhttp As New MSXML2.XMLHTTP60
    Text1.Text = ""
    Dim objhttp As Object
    Set objhttp = CreateObject("Msxml2.XMLHTTP.6.0")
    With objhttp
        .Open "GET", "https://www.howsmyssl.com/a/check", False
        .setRequestHeader "User-Agent", "Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0"
        .setRequestHeader "Content-type", "text/html"
        .send
        
        tls = retTLS(.responseText)
        Text1.Text = String$(160, "-") & vbCrLf & "MSXML2.XMLHTTP.6.0 - " & _
             "TLS Max Version : " + CStr(tls) & vbCrLf & _
             String$(160, "-") & vbCrLf & .getAllResponseHeaders & vbCrLf & .responseText & vbCrLf & Text1.Text
    End With
    
exit_MSXMLHttpBtn_Click:
    Set objhttp = Nothing
    Exit Sub

err_MSXMLHttpBtn_Click:
    MsgBox "Error " & Err.Number & ": " & Err.Description, , "Error " & Err.Number
    Resume exit_MSXMLHttpBtn_Click
End Sub


Private Sub WinHTTPBtn_Click()
    On Error Resume Next
    Dim strErrors As String
    Dim tls As Double
    
    ' Create a reference to "Microsoft WinHTTP Services 5.1" (Project->References) if you want to use the next line
    ' and rem out the 2 lines that follow this:
    ' Dim objhttp As New WinHttp.WinHttpRequest51
    
    Text1.Text = ""
    Dim HTTPRequest As Object
    Set HTTPRequest = CreateObject("WinHttp.WinHttpRequest.5.1")
    With HTTPRequest
        
        'This tells WinHttp to use TLS 1.0 through TLS 1.2.
        'Winhttp apparently prefers the protocols in descending order
        'or it may be a setting in the registry telling it do to that. I'm honestly not sure.
        '.Option(WinHttpRequestOption_SecureProtocols) = SecureProtocol_TLS1 Or SecureProtocol_TLS1_1 Or SecureProtocol_TLS1_2
        
        'If we get an error, TLS 1.2 isn't supported by the winhttp.dll on this machine.
        'If Err <> 0 Then
        '    strErrors = "TLS 1.2 is not supported on this machine. Setting TLS 1.2 resulted in error " & Err.Number & ": " & Err.Description & vbCrLf
        '    Err.Clear
        '    'Try setting it to TLS 1.0 through TLS 1.1
        '    .Option(WinHttpRequestOption_SecureProtocols) = SecureProtocol_TLS1 Or SecureProtocol_TLS1_1
        'End If
        
        'If we get an error, then TLS 1.1 isn't supported by the winhttp.dll on this machine.
        'If Err <> 0 Then
        '    strErrors = strErrors & "TLS 1.1 is not supported on this machine. Setting TLS 1.1 resulted in error " & Err.Number & ": " & Err.Description & vbCrLf
        '    Err.Clear
        '    On Error GoTo err_WinHTTpBtn_Click
        '    'Try setting TLS 1.0 only
        '    .Option(WinHttpRequestOption_SecureProtocols) = SecureProtocol_TLS1
        'End If
        
        'Allow redirects
        .Option(WinHttpRequestOption_EnableRedirects) = True
        'Enable Https To Http Redirects
        .Option(WinHttpRequestOption_EnableHttpsToHttpRedirects) = True
        'Enable Http 1.1
        .Option(WinHttpRequestOption_EnableHttp1_1) = True
        'Ignore all certificate errors
        .Option(WinHttpRequestOption_SslErrorIgnoreFlags) = SslErrorFlag_Ignore_All
        'Allow 5 seconds for everything to do what it has to do
        .setTimeouts 5000, 5000, 5000, 5000
        .Open "GET", "https://www.howsmyssl.com/a/check", False
        .setRequestHeader "User-Agent", "Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0"
        .setRequestHeader "Content-type", "text/html"
        .send
        tls = retTLS(.responseText)
        Text1.Text = String$(160, "-") & vbCrLf & "WinHttp.WinHTTPRequest.5.1 - " & _
                    "TLS Max Version : " + CStr(tls) & vbCrLf & _
                     strErrors & String$(160, "-") & vbCrLf & _
                     .getAllResponseHeaders & vbCrLf & .responseText & vbCrLf & Text1.Text
    End With

exit_WinHTTpBtn_Click:
    Set HTTPRequest = Nothing
    Exit Sub

err_WinHTTpBtn_Click:
    MsgBox "Error " & Err.Number & ": " & Err.Description & ". The operating system probably doesn't support any version of TLS.", , "Error " & Err.Number
    Resume exit_WinHTTpBtn_Click
End Sub

Private Sub Form_Load()
    Text1.Text = vbNullString
End Sub



